"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractInstantiationInfo = exports.ContractInfo = exports.get_token_type = exports.TypeOfToken = exports.Pagination = exports.TokenSaleConfig = exports.TokenTypeAmount = exports.TokenPairAmount = exports.TokenPair = void 0;
class TokenPair {
    constructor(token_0, token_1) {
        this.token_0 = token_0;
        this.token_1 = token_1;
    }
}
exports.TokenPair = TokenPair;
class TokenPairAmount {
    constructor(pair, amount_0, amount_1) {
        this.pair = pair;
        this.amount_0 = amount_0;
        this.amount_1 = amount_1;
    }
}
exports.TokenPairAmount = TokenPairAmount;
class TokenTypeAmount {
    constructor(token, amount) {
        this.token = token;
        this.amount = amount;
    }
}
exports.TokenTypeAmount = TokenTypeAmount;
class TokenSaleConfig {
    constructor(
    /**
     * The token that will be used to buy the SNIP20.
     */
    input_token, 
    /**
     * The total amount that each participant is allowed to buy.
     */
    max_allocation, 
    /**
     * The minimum amount that each participant is allowed to buy.
     */
    min_allocation, 
    /**
     * The maximum number of participants allowed.
     */
    max_seats, 
    /**
     * The price for a single token.
     */
    rate, sold_token, 
    /**
     * The addresses that are eligible to participate in the sale.
     */
    whitelist) {
        this.input_token = input_token;
        this.max_allocation = max_allocation;
        this.min_allocation = min_allocation;
        this.max_seats = max_seats;
        this.rate = rate;
        this.sold_token = sold_token;
        this.whitelist = whitelist;
    }
}
exports.TokenSaleConfig = TokenSaleConfig;
class Pagination {
    constructor(start, 
    /**
     * Max is 30.
     */
    limit) {
        this.start = start;
        this.limit = limit;
    }
}
exports.Pagination = Pagination;
var TypeOfToken;
(function (TypeOfToken) {
    TypeOfToken[TypeOfToken["Native"] = 0] = "Native";
    TypeOfToken[TypeOfToken["Custom"] = 1] = "Custom";
})(TypeOfToken = exports.TypeOfToken || (exports.TypeOfToken = {}));
function get_token_type(token) {
    const raw = token;
    if (raw.hasOwnProperty('native_token')) {
        return TypeOfToken.Native;
    }
    return TypeOfToken.Custom;
}
exports.get_token_type = get_token_type;
class ContractInfo {
    constructor(code_hash, address) {
        this.code_hash = code_hash;
        this.address = address;
    }
}
exports.ContractInfo = ContractInfo;
class ContractInstantiationInfo {
    constructor(code_hash, id) {
        this.code_hash = code_hash;
        this.id = id;
    }
}
exports.ContractInstantiationInfo = ContractInstantiationInfo;
